=== debian/changelog ===
waylandpp (0.2.5-2~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 10 Feb 2020 12:07:09 -0800

waylandpp (0.2.5-2) unstable; urgency=medium

  [ Balint Reczey ]
  * Update symbols file(s)

  [ Helmut Grohne ]
  * Fix FTBFS: Mark a template symbol as optional
  * Fix FTCBFS: Pass a WAYLAND_SCANNERPP to cmake. (Closes: #946078)

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 18 Dec 2019 15:40:57 +0100

waylandpp (0.2.5-1) unstable; urgency=medium

  * debian/control: Setting myself as the Maintainer to get notified about bugs.
    Thanks to Wolfgang Schupp for the initial packaging
  * Clean up symbols files manually

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 04 Jun 2019 13:39:25 +0200

waylandpp (0.2.5-1~exp2) experimental; urgency=medium

  * Create symbols files with amd64 symbols
  * Build-depend on pkg-kde-tools and use pkgkde-symbolshelper in the build

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 03 Jun 2019 23:40:23 +0200

waylandpp (0.2.5-1~exp1) experimental; urgency=medium

  [ Balint Reczey ]
  * Drop template-only packaging files
  * Packaging is in 3.0 (quilt) format
  * Bump compat level to 12
  * Fix debian/copyright
  * debian/rules: Drop templates
  * debian/control:
    - Extend descriptions
    - wayland-scanner++ is Multiarch: allowed
    - Tidy up using cme fix
    - Point Vcs-* to Salsa
    - Add myself as uploader
  * Fix building unstable protocols
  * Append major SO version to library package names
  * Make the -dev package depend on libraries of the same binary version
  * Fix library SO versioning
  * First upload to Debian (Closes: #922522)
  * Add symbols files
  * Add Salsa CI configuration
  * Fix package descriptions
  * Fix debian/copyright
  * New upstream version 0.2.5
  * Drop obsolete patches
  * Update copyright

  [ wsnipex ]
  * Initial packaging

 -- Balint Reczey <rbalint@ubuntu.com>  Sun, 24 Feb 2019 21:41:19 +0100
