=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with pkgkde_symbolshelper

ifneq (,$(filter cross,$(DEB_BUILD_PROFILES)))
override_dh_auto_configure:
	dh_auto_configure -- -DWAYLAND_SCANNERPP=$(shell which wayland-scanner++)
endif

override_dh_strip:
	dh_strip --no-automatic-dbgsym
