## waylandpp 0.2.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,19 +21,17 @@
 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-project(waylandpp)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.4)
+project(waylandpp VERSION 0.2.8 LANGUAGES CXX)
 
 # packages
 include(FindPkgConfig)
 include(GNUInstallDirs)
+include(CMakeDependentOption)
+include(CMakePackageConfigHelpers)
 find_package(Doxygen)
 
 # version information
-set(WAYLANDPP_VERSION_MAJOR 0)
-set(WAYLANDPP_VERSION_MINOR 2)
-set(WAYLANDPP_VERSION_PATCH 5)
-set(WAYLANDPP_VERSION "${WAYLANDPP_VERSION_MAJOR}.${WAYLANDPP_VERSION_MINOR}.${WAYLANDPP_VERSION_PATCH}")
 configure_file(include/wayland-version.hpp.in wayland-version.hpp @ONLY)
 
 # path shorthands
@@ -41,10 +39,19 @@
 set(INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/waylandpp")
 
 # user options
-set(BUILD_SCANNER ON CACHE BOOL "whether to build wayland-scanner++")
-set(BUILD_LIBRARIES ON CACHE BOOL "whether to build the libraries")
-set(BUILD_DOCUMENTATION ${DOXYGEN_FOUND} CACHE BOOL "Create and install the HTML based API documentation (requires Doxygen)")
-set(BUILD_EXAMPLES OFF CACHE BOOL "whether to build the examples (requires BUILD_LIBRARIES to be ON)")
+option(BUILD_SCANNER "whether to build wayland-scanner++" ON)
+option(BUILD_LIBRARIES "whether to build the libraries" ON)
+cmake_dependent_option(BUILD_SHARED_LIBS "Build shared libraries" ON
+  "BUILD_LIBRARIES" OFF)
+option(BUILD_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
+cmake_dependent_option(BUILD_EXAMPLES
+  "whether to build the examples (requires BUILD_LIBRARIES to be ON)" OFF
+  "BUILD_LIBRARIES" OFF)
+
+# Do not report undefined references in libraries, since the protocol libraries cannot be used on their own.
+if(CMAKE_SHARED_LINKER_FLAGS)
+  string(REPLACE "-Wl,--no-undefined" " " CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS})
+endif()
 
 # variables for .pc.in files
 set(prefix "${CMAKE_INSTALL_PREFIX}")
@@ -54,12 +61,28 @@
 set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
 set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
 
+set(install_namespace "Waylandpp")
+
 # C++ 11
 set(CMAKE_CXX_STANDARD 11)
+
+# sets ${PREFIX}_LIBRARIES to the libraries' full path
+function(pkg_libs_full_path PREFIX)
+  if(${PREFIX}_FOUND)
+    unset(LIBS_TMP CACHE)
+    foreach(LIB ${${PREFIX}_LIBRARIES})
+      unset(LIB_TMP CACHE)
+      find_library(LIB_TMP ${LIB} PATHS ${${PREFIX}_LIBRARY_DIRS})
+      list(APPEND LIBS_TMP ${LIB_TMP})
+    endforeach()
+    set(${PREFIX}_LIBRARIES ${LIBS_TMP} PARENT_SCOPE)
+  endif()
+endfunction()
 
 # build scanner
 if(BUILD_SCANNER)
   pkg_check_modules(PUGIXML REQUIRED "pugixml>=1.4")
+  pkg_libs_full_path(PUGIXML)
   add_executable(wayland-scanner++ scanner/scanner.cpp)
   target_link_libraries(wayland-scanner++ ${PUGIXML_LIBRARIES})
   target_compile_options(wayland-scanner++ PUBLIC ${PUGIXML_CFLAGS})
@@ -82,8 +105,11 @@
 
   # required libraries
   pkg_check_modules(WAYLAND_CLIENT REQUIRED "wayland-client>=1.11.0")
+  pkg_libs_full_path(WAYLAND_CLIENT)
   pkg_check_modules(WAYLAND_EGL REQUIRED wayland-egl)
+  pkg_libs_full_path(WAYLAND_EGL)
   pkg_check_modules(WAYLAND_CURSOR REQUIRED wayland-cursor)
+  pkg_libs_full_path(WAYLAND_CURSOR)
 
   # generate protocol source/headers from protocol XMLs
   set(PROTO_XMLS "${CMAKE_SOURCE_DIR}/protocols/wayland.xml")
@@ -112,37 +138,67 @@
     DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
 
   # library building helper functions
-  function(define_library TARGET CFLAGS LDFLAGS HEADERS)
-    add_library("${TARGET}" SHARED ${ARGN})
-    target_include_directories("${TARGET}" PUBLIC "include" "${CMAKE_CURRENT_BINARY_DIR}") # latter for wayland-version.hpp
+  function(define_library TARGET CFLAGS LIBRARIES HEADERS)
+    add_library("${TARGET}" ${ARGN})
+    add_library(${install_namespace}::${TARGET} ALIAS ${TARGET})
+    get_target_property(libtype "${TARGET}" TYPE)
+    target_include_directories("${TARGET}" PUBLIC
+      $<BUILD_INTERFACE:include;${CMAKE_CURRENT_BINARY_DIR}> # latter for wayland-version.hpp
+      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+      )
     target_compile_options("${TARGET}" PUBLIC ${CFLAGS})
-    target_link_libraries("${TARGET}" ${LDFLAGS})
+    target_link_libraries("${TARGET}" PUBLIC ${LIBRARIES})
     set_target_properties("${TARGET}" PROPERTIES
       PUBLIC_HEADER "${HEADERS}"
-      VERSION "${WAYLANDPP_VERSION_MAJOR}.${WAYLANDPP_VERSION_MINOR}.${WAYLANDPP_VERSION_PATCH}"
-      SOVERSION ${WAYLANDPP_VERSION_MAJOR})
+      VERSION "${PROJECT_VERSION}"
+      SOVERSION ${PROJECT_VERSION_MAJOR})
     configure_file("${TARGET}.pc.in" "${TARGET}.pc" @ONLY)
     set_target_properties("${TARGET}" PROPERTIES RESOURCE "${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc")
   endfunction()
 
-  define_library(wayland-client++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
+  define_library(wayland-client++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "include/wayland-client.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-version.hpp"
     src/wayland-client.cpp src/wayland-util.cpp wayland-client-protocol.cpp wayland-client-protocol.hpp)
-  define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
+  # Report undefined references only for the base library.
+  if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
+    target_link_options(wayland-client++ PRIVATE "-Wl,--no-undefined")
+  endif()
+  define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-extra.hpp"
     wayland-client-protocol-extra.cpp wayland-client-protocol-extra.hpp wayland-client-protocol.hpp)
-  define_library(wayland-client-unstable++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LDFLAGS}"
+  target_link_libraries(wayland-client-extra++ INTERFACE wayland-client++)
+  define_library(wayland-client-unstable++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-unstable.hpp"
     wayland-client-protocol-unstable.cpp wayland-client-protocol-unstable.hpp wayland-client-protocol.hpp)
-  define_library(wayland-egl++ "${WAYLAND_EGL_CFLAGS}" "${WAYLAND_EGL_LDFLAGS}" include/wayland-egl.hpp src/wayland-egl.cpp wayland-client-protocol.hpp)
-  define_library(wayland-cursor++ "${WAYLAND_CURSOR_CFLAGS}" "${WAYLAND_CURSOR_LDFLAGS}" include/wayland-cursor.hpp src/wayland-cursor.cpp wayland-client-protocol.hpp)
+  target_link_libraries(wayland-client-unstable++ INTERFACE wayland-client-extra++)
+  define_library(wayland-egl++ "${WAYLAND_EGL_CFLAGS}" "${WAYLAND_EGL_LIBRARIES}" include/wayland-egl.hpp src/wayland-egl.cpp wayland-client-protocol.hpp)
+  target_link_libraries(wayland-egl++ INTERFACE wayland-client++)
+  define_library(wayland-cursor++ "${WAYLAND_CURSOR_CFLAGS}" "${WAYLAND_CURSOR_LIBRARIES}" include/wayland-cursor.hpp src/wayland-cursor.cpp wayland-client-protocol.hpp)
+  target_link_libraries(wayland-cursor++ INTERFACE wayland-client++)
 
   # Install libraries
   install(FILES ${PROTO_XMLS} ${PROTO_XMLS_EXTRA} ${PROTO_XMLS_UNSTABLE} DESTINATION "${INSTALL_FULL_PKGDATADIR}/protocols")
-  install(TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++
+  install(TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++ EXPORT ${CMAKE_PROJECT_NAME}-targets
     LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
+    ARCHIVE DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
     PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}"
     RESOURCE DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
+
+  # create and install CMake-Config files
+  set(_CMAKECONFIGDIR "${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME}")
+
+  install(EXPORT ${CMAKE_PROJECT_NAME}-targets
+        DESTINATION "${_CMAKECONFIGDIR}"
+        NAMESPACE ${install_namespace}::)
+  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
+    COMPATIBILITY AnyNewerVersion)
+  configure_package_config_file(waylandpp-config.cmake.in
+                              ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
+                              INSTALL_DESTINATION "${_CMAKECONFIGDIR}")
+
+  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
+                ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
+          DESTINATION "${_CMAKECONFIGDIR}")
 endif()
 
 if(BUILD_EXAMPLES)
