=== debian/changelog ===
waylandpp (0.2.8-2) unstable; urgency=medium

  * Orphaning the package
  * debian/control: Move packaging under the Debian project on Salsa
  * debian/watch: Fix pattern

 -- Balint Reczey <balint@balintreczey.hu>  Fri, 14 Jan 2022 20:05:05 +0100

waylandpp (0.2.8-1) unstable; urgency=medium

  * ACK NMU, thanks Christian for the fix
  * New upstream version 0.2.8
  * Drop symbols files in favor of using shlibs files
  * Drop 01_FTBFS-gcc-10.patch merged upstream

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 08 Aug 2020 17:56:52 +0200

waylandpp (0.2.5-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with gcc 10 (Gentoo patch) (CLoses: #957924)

 -- Christian Marillat <marillat@debian.org>  Tue, 28 Jul 2020 23:38:44 +0200
