=== debian/control ===
--- 
+++ 
@@ -1,20 +1,19 @@
 Source: waylandpp
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Balint Reczey <rbalint@ubuntu.com>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 12),
                cmake,
                pkg-config,
                pkg-kde-tools,
-               libpugixml-dev (>= 1.9),
+               libpugixml-dev,
                libwayland-dev,
                libwayland-egl1-mesa,
                libegl1-mesa-dev,
                wayland-scanner++:any <cross>,
 Standards-Version: 4.3.0
-Vcs-Browser: https://salsa.debian.org/rbalint/waylandpp
-Vcs-Git: https://salsa.debian.org/rbalint/waylandpp.git
+Vcs-Browser: https://salsa.debian.org/debian/waylandpp
+Vcs-Git: https://salsa.debian.org/debian/waylandpp.git
 Homepage: https://github.com/NilsBrause/waylandpp
 
 Package: waylandpp-dev
