=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2014-2019 Philipp Kerling, Nils Christopher Brause
+# Copyright (c) 2014-2022 Philipp Kerling, Nils Christopher Brause
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
