=== debian/changelog ===
waylandpp (0.2.10-1) unstable; urgency=medium

  * New upstream version 0.2.10, Closes: #1006812
  * added a build-dependency on doxygen

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 16 Apr 2022 15:44:00 +0200

waylandpp (0.2.9-2) unstable; urgency=medium

  * moved "usr/lib/*/cmake/*" to d/not-installed : those files contain
    paths of the build process, which are not reproducible, hence triggering
    errors for the reproducible-build test.

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 04 Mar 2022 11:10:53 +0100

waylandpp (0.2.9-1) unstable; urgency=medium

  * adopted the package. Closes: #1003739
  * new upstream version
  * bumped Standards-Version: 4.6.0.2, debhelper-compat (= 13)
  * fixed d/waylandpp-dev.install for missing files reported by dh_missing;
    added usr/lib/*/libwayland-client-unstable++.so.* to a new file
    d/not-installed

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 03 Mar 2022 17:53:51 +0100
