=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: waylandpp
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Georges Khaznadar <georgesk@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                pkg-config,
                pkg-kde-tools,
@@ -11,7 +11,8 @@
                libwayland-egl1-mesa,
                libegl1-mesa-dev,
                wayland-scanner++:any <cross>,
-Standards-Version: 4.3.0
+	       doxygen,
+Standards-Version: 4.6.0.2
 Vcs-Browser: https://salsa.debian.org/debian/waylandpp
 Vcs-Git: https://salsa.debian.org/debian/waylandpp.git
 Homepage: https://github.com/NilsBrause/waylandpp
