## waylandpp 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.4)
-project(waylandpp VERSION 0.2.10 LANGUAGES CXX)
+project(waylandpp VERSION 1.0.0 LANGUAGES CXX)
 
 # packages
 include(FindPkgConfig)
@@ -48,6 +48,7 @@
 cmake_dependent_option(BUILD_EXAMPLES
   "whether to build the examples (requires BUILD_LIBRARIES to be ON)" OFF
   "BUILD_LIBRARIES" OFF)
+option(BUILD_SERVER "whether to build the server bindings." ON)
 
 # Do not report undefined references in libraries, since the protocol libraries cannot be used on their own.
 if(CMAKE_SHARED_LINKER_FLAGS)
@@ -110,7 +111,9 @@
 
   # required libraries
   pkg_check_modules(WAYLAND_CLIENT REQUIRED "wayland-client>=1.11.0")
-  pkg_libs_full_path(WAYLAND_CLIENT)
+  if(BUILD_SERVER)
+    pkg_check_modules(WAYLAND_SERVER REQUIRED "wayland-server>=1.17.0")
+  endif()
   pkg_check_modules(WAYLAND_EGL REQUIRED wayland-egl)
   pkg_libs_full_path(WAYLAND_EGL)
   pkg_check_modules(WAYLAND_CURSOR REQUIRED wayland-cursor)
@@ -142,6 +145,30 @@
     COMMAND "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-client-protocol-extra.hpp"
     DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
 
+  if(BUILD_SERVER)
+    set(PROTO_FILES
+      "wayland-server-protocol.hpp"
+      "wayland-server-protocol.cpp")
+    set(PROTO_FILES_EXTRA
+      "wayland-server-protocol-extra.hpp"
+      "wayland-server-protocol-extra.cpp")
+    set(PROTO_FILES_UNSTABLE
+      "wayland-server-protocol-unstable.hpp"
+      "wayland-server-protocol-unstable.cpp")
+    add_custom_command(
+      OUTPUT ${PROTO_FILES}
+      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS} ${PROTO_FILES}
+      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS})
+    add_custom_command(
+      OUTPUT ${PROTO_FILES_EXTRA}
+      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS_EXTRA} ${PROTO_FILES_EXTRA} "-x" "wayland-server-protocol.hpp"
+      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_EXTRA})
+    add_custom_command(
+      OUTPUT ${PROTO_FILES_UNSTABLE}
+      COMMAND "${WAYLAND_SCANNERPP}" "-s" "on" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_UNSTABLE} "-x" "wayland-server-protocol-extra.hpp"
+      DEPENDS "${WAYLAND_SCANNERPP}" ${PROTO_XMLS_UNSTABLE} ${PROTO_FILES_EXTRA})
+  endif()
+
   # library building helper functions
   function(define_library TARGET CFLAGS LIBRARIES HEADERS)
     add_library("${TARGET}" ${ARGN})
@@ -168,6 +195,23 @@
   if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
     target_link_options(wayland-client++ PRIVATE "-Wl,--no-undefined")
   endif()
+  if(BUILD_SERVER)
+    define_library(wayland-server++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
+      "include/wayland-server.hpp;include/wayland-util.hpp;${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol.hpp"
+      src/wayland-server.cpp src/wayland-util.cpp wayland-server-protocol.cpp wayland-server-protocol.hpp)
+    # Report undefined references only for the base library.
+    if(${CMAKE_VERSION} VERSION_GREATER "3.14.0")
+      target_link_options(wayland-server++ PRIVATE "-Wl,--no-undefined")
+    endif()
+    define_library(wayland-server-extra++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
+      "${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol-extra.hpp"
+      wayland-server-protocol-extra.cpp wayland-server-protocol-extra.hpp wayland-server-protocol.hpp)
+    target_link_libraries(wayland-server-extra++ INTERFACE wayland-server++)
+    define_library(wayland-server-unstable++ "${WAYLAND_SERVER_CFLAGS}" "${WAYLAND_SERVER_LIBRARIES}"
+      "${CMAKE_CURRENT_BINARY_DIR}/wayland-server-protocol-unstable.hpp"
+      wayland-server-protocol-unstable.cpp wayland-server-protocol-unstable.hpp wayland-server-protocol.hpp)
+    target_link_libraries(wayland-server-unstable++ INTERFACE wayland-server-extra++)
+  endif()
   define_library(wayland-client-extra++ "${WAYLAND_CLIENT_CFLAGS}" "${WAYLAND_CLIENT_LIBRARIES}"
     "${CMAKE_CURRENT_BINARY_DIR}/wayland-client-protocol-extra.hpp"
     wayland-client-protocol-extra.cpp wayland-client-protocol-extra.hpp wayland-client-protocol.hpp)
@@ -186,56 +230,8 @@
   list(APPEND INSTALL_TARGETS wayland-client++ wayland-client-extra++ wayland-egl++ wayland-cursor++)
   if (INSTALL_UNSTABLE_PROTOCOLS)
 	  list(APPEND INSTALL_TARGETS wayland-client-unstable++)
-  endif()
-  install(TARGETS ${INSTALL_TARGETS} EXPORT ${CMAKE_PROJECT_NAME}-targets
-    LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
-    ARCHIVE DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
-    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}"
-    RESOURCE DESTINATION "${INSTALL_FULL_PKGCONFIGDIR}")
-
-  # create and install CMake-Config files
-  set(_CMAKECONFIGDIR "${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME}")
-
-  install(EXPORT ${CMAKE_PROJECT_NAME}-targets
-        DESTINATION "${_CMAKECONFIGDIR}"
-        NAMESPACE ${install_namespace}::)
-  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
-    COMPATIBILITY AnyNewerVersion)
-  configure_package_config_file(waylandpp-config.cmake.in
-                              ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
-                              INSTALL_DESTINATION "${_CMAKECONFIGDIR}")
-
-  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config-version.cmake
-                ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}-config.cmake
-          DESTINATION "${_CMAKECONFIGDIR}")
-endif()
-
-if(BUILD_EXAMPLES)
-  if(NOT BUILD_LIBRARIES)
-    message(FATAL_ERROR "Cannot build examples without building libraries")
-  endif()
-  add_subdirectory(example)
-endif()
-
-if(BUILD_DOCUMENTATION)
-  if(NOT DOXYGEN_FOUND)
-    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
-  endif()
-
-  set(WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc")
-  set(WAYLANDPP_BUILD_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
-  configure_file(Doxyfile.in Doxyfile @ONLY)
-
-  add_custom_command(
-    OUTPUT "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html/index.html"
-    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" ${PROTO_FILES} ${PROTO_FILES_EXTRA} ${PROTO_FILES_UNSTABLE}
-    COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
-    COMMENT "Generating API documentation with Doxygen"
-    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
-    VERBATIM
-  )
-  add_custom_target(doc ALL DEPENDS "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html/index.html")
-
-  install(DIRECTORY "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/man/" DESTINATION ${CMAKE_INSTALL_FULL_MANDIR})
-  install(DIRECTORY "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/html" "${WAYLANDPP_DOXYGEN_OUTPUT_DIRECTORY}/latex" DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
-endif()
+    if(BUILD_SERVER)
+	    list(APPEND INSTALL_TARGETS wayland-server-unstable++)
+    endif()
+  endif()
+  if(BUILD_SERVER)
