=== debian/changelog ===
waylandpp (1.0.0-6) unstable; urgency=medium

  * replaced a build-dependency: libwayland-egl1-mesa -> libegl1
  Closes: #1070062

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 01 May 2024 19:27:19 +0200

waylandpp (1.0.0-5) unstable; urgency=medium

  * added '#include <cstdint>' stances. Closes: #1037893

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 17 Jul 2023 19:12:01 +0200

waylandpp (1.0.0-4) unstable; urgency=medium

  * added usr/lib/*/libwayland-client-unstable++.so.* in the file
    d/libwayland-client++1.install, removed it from d/not-installed.
    Closes: #1035462
  * fixed Standards-Version: 4.6.0.2 -> 4.6.2
  * declared libwayland-client-unstable++.so in d/libwayland-client++1.shlib

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 03 May 2023 17:39:41 +0200

waylandpp (1.0.0-3) unstable; urgency=medium

  * Closes: #1011107, thanks to Thadeu Lima de Souza Cascardo;
    added conflict/replace clauses for libraries

 -- Georges Khaznadar <georgesk@debian.org>  Tue, 17 May 2022 09:32:49 +0200

waylandpp (1.0.0-2) unstable; urgency=medium

  * used Vasyl Gello's debdiff, thanks!
    Closes: #1010921
    Closes: #1010956

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 14 May 2022 17:23:01 +0200

waylandpp (1.0.0-1) unstable; urgency=medium

  * new upstream version 1.0.0
  * added the new binary package libwayland-server++0, which contains
    new libraries created upstream
  * created a separate package waylandpp-doc. Closes: #1010087

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 06 May 2022 18:13:23 +0200
