=== debian/watch ===
version=4
https://github.com/NilsBrause/waylandpp/tags .*archive/refs/tags/?(\d\S*).*\.tar\.gz
